{$A+,B-,D-,E-,F+,G-,I+,L-,N-,R-,S-,V-,X-}
{$M 16384,0,0}
program HugeCalc;

 uses Calc;

 const Copyright : string[82] = 'HUGECALC 1.0, Copyright 1991 by ' +
       'Neil J. Rubenking'#13#10'PC Magazine '#254'Neil J. Rubenking';

 function AllNums(var a : string) : boolean;
 var n : byte;
 begin
   AllNums := FALSE;
   for n := 1 to Length(a) do
     if (a[n] < '0') OR (a[n] > '9') then Exit;
   AllNums := TRUE;
 end;

 function IsDevice(var f : text) : boolean; Assembler;
 ASM
   MOV  AH, 44h        {IOCTL function}
   MOV  AL, 00h        {get device info subfunction}
   LES  DI, f
   MOV  BX, ES:[DI]    {handle in BX}
   INT  21h
   MOV  AL, 0          {return value is FALSE}
   JC  @end
   TEST DX, 80h        {check is-device bit}
   JZ  @end            {if NOT set, just end}
   INC  AL             {return value is TRUE}
  @end:
 END;

 {-- Global valiables --}

 var op, opRand, result, rem : string;
     operation               : char;

 function GotParams : boolean;
 { Purpose: 
   Returns TRUE if parameters are correctly passed on the command line -
   and assigns them to the correct variables if so }

 var s : string[1];
     b : byte;
 begin
   GotParams := FALSE;
   b := 2;
   if (NOT IsDevice(Input)) AND NOT Eof(Input) then
   begin
     Readln(op);
     Dec(b);
   end;
   if ParamCount < b then
   begin
     writeln(Copyright);
     writeln('Enter "HC ## op ##", where op is +,-,*,/, or ^');
     writeln('   or "HC ## !" for factorial');
     writeln('HC does not support floating-point');
     Exit;
   end;
   if b = 2 then op := ParamStr(1);
   if NOT AllNums(op) then
   begin
     writeln(Copyright);
     writeln('*',op,'" is not a positive integer.');
     Exit;
   end;
   s := ParamStr(b);
   operation := s[1];
   case operation of
     '!' : ;
     '+','-','*','/','^' :
           begin
             if ParamCount < Succ(b) then
             begin
               writeln(Copyright);
               writeln('The operator ', operation, ' requires a second operand');
               Exit;
             end;
             opRand := ParamStr(b+1);
             if NOT AllNums(opRand) then
             begin
               writeln(Copyright);
               writeln('"',opRand,'" is not a positive integer.');
               Exit;
             end;
           end;
     else begin
       writeln(Copyright);
       writeln('Valid operations are +,-,*,/,! and ^');
       Exit;
     end;
   end;
   GotParams := TRUE;
 end;

 function AddComma(ww : string) : string;
 var posn, minloc : word;
 begin
   if ww = '' then 
     AddComma := '*ERROR*'
   else begin
     posn := Succ(Length(ww));
     minloc := 4;
     if ww[1] = '-' then Inc(minloc);
     while (posn > minloc) AND (Length(ww) < 255) do
     begin
       Dec(posn,3);
       Move(ww[posn], ww[Succ(posn)], Succ(Length(ww) - posn));
       ww[posn] := ',';
       Inc(ww[0]);
     end;
     AddComma := ww;
   end;
 end;

 {-- Main program --}

 begin
   if GotParams then
   begin
     case operation of
       '+' : begin
               if IsDevice(Output) then write('       SUM: ');
               result := Add(op, opRand);
               if IsDevice(Output) then 
                 writeln(AddComma(result))
               else
                 writeln(result);
             end;
       '-' : begin
               if IsDevice(Output) then write('DIFFERENCE: ');
               result := Sub(op, opRand);
               if IsDevice(Output) then 
                 writeln(AddComma(result))
               else
                 writeln(result);
             end;
       '*' : begin
               if IsDevice(Output) then write('   PRODUCT: ');
               result := Prod(op, opRand);
               if IsDevice(Output) then 
                 writeln(AddComma(result))
               else
                 writeln(result);
             end;
       '/' : begin
               if IsDevice(Output) then write('  QUOTIENT: ');
               result := Divide(op, opRand, rem);
               if IsDevice(Output) then
               begin
                 writeln(AddComma(result));
                 write(' REMAINDER: ');
                 writeln(AddComma(rem));
               end else
                 writeln(result);
             end;
       '!' : begin
               if IsDevice(Output) then write(' FACTORIAL: ');
               result := Fact(op);
               if IsDevice(Output) then 
                 writeln(AddComma(result))
               else
                 writeln(result);
             end;
       '^' : begin
               if IsDevice(Output) then write('     POWER: ');
               result := Power(op, opRand);
               if IsDevice(Output) then 
                 writeln(AddComma(result))
               else
                 writeln(result);
             end;
     end;
   end;
 end.
